/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the PostChannelsChannelIdInteractionsIdPreviewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PostChannelsChannelIdInteractionsIdPreviewRequest{}

// PostChannelsChannelIdInteractionsIdPreviewRequest struct for PostChannelsChannelIdInteractionsIdPreviewRequest
type PostChannelsChannelIdInteractionsIdPreviewRequest struct {
	ConversationId *string `json:"conversation_id,omitempty"`
	Event map[string]interface{} `json:"event,omitempty"`
}

// NewPostChannelsChannelIdInteractionsIdPreviewRequest instantiates a new PostChannelsChannelIdInteractionsIdPreviewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPostChannelsChannelIdInteractionsIdPreviewRequest() *PostChannelsChannelIdInteractionsIdPreviewRequest {
	this := PostChannelsChannelIdInteractionsIdPreviewRequest{}
	return &this
}

// NewPostChannelsChannelIdInteractionsIdPreviewRequestWithDefaults instantiates a new PostChannelsChannelIdInteractionsIdPreviewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPostChannelsChannelIdInteractionsIdPreviewRequestWithDefaults() *PostChannelsChannelIdInteractionsIdPreviewRequest {
	this := PostChannelsChannelIdInteractionsIdPreviewRequest{}
	return &this
}

// GetConversationId returns the ConversationId field value if set, zero value otherwise.
func (o *PostChannelsChannelIdInteractionsIdPreviewRequest) GetConversationId() string {
	if o == nil || IsNil(o.ConversationId) {
		var ret string
		return ret
	}
	return *o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostChannelsChannelIdInteractionsIdPreviewRequest) GetConversationIdOk() (*string, bool) {
	if o == nil || IsNil(o.ConversationId) {
		return nil, false
	}
	return o.ConversationId, true
}

// HasConversationId returns a boolean if a field has been set.
func (o *PostChannelsChannelIdInteractionsIdPreviewRequest) HasConversationId() bool {
	if o != nil && !IsNil(o.ConversationId) {
		return true
	}

	return false
}

// SetConversationId gets a reference to the given string and assigns it to the ConversationId field.
func (o *PostChannelsChannelIdInteractionsIdPreviewRequest) SetConversationId(v string) {
	o.ConversationId = &v
}

// GetEvent returns the Event field value if set, zero value otherwise.
func (o *PostChannelsChannelIdInteractionsIdPreviewRequest) GetEvent() map[string]interface{} {
	if o == nil || IsNil(o.Event) {
		var ret map[string]interface{}
		return ret
	}
	return o.Event
}

// GetEventOk returns a tuple with the Event field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostChannelsChannelIdInteractionsIdPreviewRequest) GetEventOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Event) {
		return map[string]interface{}{}, false
	}
	return o.Event, true
}

// HasEvent returns a boolean if a field has been set.
func (o *PostChannelsChannelIdInteractionsIdPreviewRequest) HasEvent() bool {
	if o != nil && !IsNil(o.Event) {
		return true
	}

	return false
}

// SetEvent gets a reference to the given map[string]interface{} and assigns it to the Event field.
func (o *PostChannelsChannelIdInteractionsIdPreviewRequest) SetEvent(v map[string]interface{}) {
	o.Event = v
}

func (o PostChannelsChannelIdInteractionsIdPreviewRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PostChannelsChannelIdInteractionsIdPreviewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ConversationId) {
		toSerialize["conversation_id"] = o.ConversationId
	}
	if !IsNil(o.Event) {
		toSerialize["event"] = o.Event
	}
	return toSerialize, nil
}

type NullablePostChannelsChannelIdInteractionsIdPreviewRequest struct {
	value *PostChannelsChannelIdInteractionsIdPreviewRequest
	isSet bool
}

func (v NullablePostChannelsChannelIdInteractionsIdPreviewRequest) Get() *PostChannelsChannelIdInteractionsIdPreviewRequest {
	return v.value
}

func (v *NullablePostChannelsChannelIdInteractionsIdPreviewRequest) Set(val *PostChannelsChannelIdInteractionsIdPreviewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullablePostChannelsChannelIdInteractionsIdPreviewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullablePostChannelsChannelIdInteractionsIdPreviewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePostChannelsChannelIdInteractionsIdPreviewRequest(val *PostChannelsChannelIdInteractionsIdPreviewRequest) *NullablePostChannelsChannelIdInteractionsIdPreviewRequest {
	return &NullablePostChannelsChannelIdInteractionsIdPreviewRequest{value: val, isSet: true}
}

func (v NullablePostChannelsChannelIdInteractionsIdPreviewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePostChannelsChannelIdInteractionsIdPreviewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


